﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IqrfDpaLib
{
    public class HdlcLayer
    {
        public static bool CheckMarks(byte[] inputBuffer, int inputLength)
        {
            if (inputBuffer[0] != 0x7E || inputBuffer[inputLength - 1] != 0x7E)
            {
                return false;
            }

            return true;
        }

        public static bool CheckCrc(byte[] inputBuffer, int inputLength)
        {
            byte calcCrc = OneWireCrc.CalcOneWireCrc(inputBuffer, 0, inputLength - 2);

            byte frameCrc = inputBuffer[inputLength - 1];

            if (frameCrc == calcCrc)
            {
                return true;
            }

            return false;
        }

        public static int PrepareInputBuffer(byte[] inputBuffer, int inputLength, byte[] outputBuffer)
        {
            outputBuffer[0] = 0x7E;

            int outputOffset = 1;

            inputBuffer[inputLength] = OneWireCrc.CalcOneWireCrc(inputBuffer, 0, inputLength - 1);

            for (int i = 0; i <= inputLength; i++)
            {
                if (inputBuffer[i] == 0x7E || inputBuffer[i] == 0x7D)
                {
                    outputBuffer[outputOffset++] = 0x7D;
                    outputBuffer[outputOffset++] = (byte)(inputBuffer[i] ^ 0x20);
                }
                else
                {
                    outputBuffer[outputOffset++] = inputBuffer[i];
                }
            }

            outputBuffer[outputOffset++] = 0x7E;

            return outputOffset;
        }

        public static int UnEscapeInputBuffer(byte[] inputBuffer, int inputLength, byte[] outputBuffer)
        {
            int outputLength = 0;

            for (int i = 1; i < inputLength; i++)
            {
                if (inputBuffer[i] == 0x7E)
                {
                    i++;
                    outputBuffer[outputLength++] = (byte)(inputBuffer[i] ^ 0x20);
                }
                else
                {
                    outputBuffer[outputLength++] = inputBuffer[i];
                }
            }

            return outputLength;
        }
    }
}
